jQuery(function ($) {
  
  if ($.inArray(pagenow, new Array('toplevel_page_gfw_settings', 'gfw_page_gfw_settings', 'toplevel_page_gfw_tests', 'gfw_page_gfw_schedule')) > 0) {
    $('.if-js-closed').removeClass('if-js-closed').addClass('closed');
    postboxes.add_postbox_toggles(pagenow);
  }

  if ($('#gfw_url').length) {
    $( '#gfw_url' ).autocomplete({   
      source: function( request, response ) {
        $.ajax({
          url: ajaxurl,
          dataType: 'json',
          data: {
            action: 'autocomplete',
            term: request.term
          },
          success: function( data ) {
            response( $.map( data, function( item ) {
              return {
                label: item.title,
                value: item.permalink
              }
            }));
          }
        });
      },
      minLength: 2
    });
  }

  function placeholderSupport() {
    var input = document.createElement('input');
    var supported = ('placeholder' in input);
    if (!supported) {
      $('.gfw-placeholder-alternative').show();
    }
  }
  placeholderSupport();

  if ($('#gfw-scan').length) {
    $('#gfw-scan').overlay({
      mask: {
        color: "#fff",
        loadSpeed: 200,
        opacity: 0.6
      },
      close: '.gfw-modal-close',
      closeOnClick: false,
      onLoad: function() {
      }
    });
  }
  
  if ($('#gfw-graph').length) {
    $('#gfw-graph').overlay({
      mask: {
        color: "#fff",
        loadSpeed: 200,
        opacity: 0.6
      },
      close: '.gfw-modal-close',
      closeOnClick: false
    });
  }
  
  $('#gfw-parameters').submit(function() {
    $('#gfw-screenshot').css('background-image','url(../wp-content/plugins/gtmetrix-for-wordpress/images/loading-screenshot.png)');
    $('#gfw-screenshot .gfw-message').text('').hide();
    $('#gfw-scanner').show();
    $('#gfw-scan').overlay().load();
    q(0);
    
    $.ajax({
      url: ajaxurl,
      dataType: 'json',
      type: 'POST',
      data: {
        action: 'save_report',
        fields: $(this).serialize(),
        security : gfwObject.gfwnonce
      },
      cache: false,
      success: function(data) {
        if (data.error) {
          $('#gfw-scanner').hide();
          $('#gfw-screenshot').css('background-image','url(../wp-content/plugins/gtmetrix-for-wordpress/images/exclamation.png)');
          $('#gfw-screenshot .gfw-message').text( data.error ).show();
        } else {
          if ($('#gfw_url').val() == $('#gfw-wpurl').val() ) {
            location.reload();
          }
          $('#gfw-screenshot').css('background-image','url(' + data.screenshot + ')');
          $('table.gfw-table > thead tr').show();
          $('table.gfw-table > tbody').prepend(data.row);
          $('table.gfw-table > tbody > tr').removeClass('odd even');
          $('table.gfw-table > tbody > tr:odd').addClass('odd');
          $('table.gfw-table > tbody > tr:even').addClass('even');
          $('p.gfw-no-posts').hide();
          window.setTimeout(
            function() {
              $('#gfw-scan').overlay().close();
            },
            1000
            ); 
        }
      }
    });
    return false;
  });

  function q(e) {
    var n = $('#gfw-scanner'),
    r = n.height() ? !0 : !1;
    !r && !n.height() ? (setTimeout(function () {
      q()
    }, 500), r = !0) : n.animate({
      top: (e ? '-' : '+') + '=221'
    }, 2E3, function () {
      if ($('#gfw-scan').overlay().isOpened()) { 
        q(!e)
      } else {
        $('#gfw-scanner').css('top', -7)
      }
    })
  }

  $('table.gfw-table td.gfw-toggle').live('click', function() {
    if ($(this).parents('tr').hasClass('report-expanded')) {
      $(this).parents('tr').removeClass('report-expanded').addClass('report-collapsed').next().hide();
    } else if ($(this).parents('tr').hasClass('report-collapsed')) {
      $(this).parents('tr').removeClass('report-collapsed').addClass('report-expanded').next().show();
    } else {
      var newRow = '<tr><td colspan="' + $(this).parents('tr').find('td').length + '" style="padding:0"></td></tr>';
      $(this).parents('tr').addClass('report-expanded').after(newRow);
      var recordId = $(this).parents('tr').attr('id').substring(5);
      $(this).parents('tr').next().find('td').load(ajaxurl, {
        action: 'expand_report',
        id: recordId
      });
    }
    return false;
  });
  
  $('.gfw-open-graph').live('click', function() {

    var eventId = $(this).attr('href');
    var graph = $(this).attr('id');

    $.ajax({
      url: ajaxurl,
      cache: false,
      dataType: 'json',
      data: {
        action: 'report_graph',
        id: eventId,
        graph: graph
      },
      success:  function( series ) {
        var options = {
          series: {
            lines: {
              show: true
            },
            points: {
              show: true
            }
          },
          xaxis: {
            mode: 'time',
            timeformat: '%b %d %H:%M%P'
          },
          grid: {
            backgroundColor: {
              colors: ['#fff', '#eee']
            }
          },
          legend: {
            container: '#gfw-graph-legend',
            noColumns: 2
          }
        };
        switch (graph) {
          case 'gfw-scores-graph':
            options.yaxis = {
              ticks: 5,
              min: 0,
              max: 100,
              tickFormatter: function (val) {
                return val + '%';
              }
            }
            break;
          case 'gfw-times-graph':
            options.yaxis = {
              ticks: 5,
              min: 0,
              tickFormatter: function (val) {
                return val.toFixed(1) + ' s';
              }
            }
            break;
          case 'gfw-sizes-graph':
            options.yaxis = {
              ticks: 5,
              min: 0,
              tickFormatter: function (val) {
                return val + ' KB';
              }
            }
            break;
        }

        var placeholder = $('#gfw-flot-placeholder');
        $('#gfw-graph').overlay().load();
        $.plot(placeholder, series, options);
      }
    });
    return false;
  });

  $('#gfw-confirm-delete a').click(function(e) {
    e.preventDefault();
    if ($(this).hasClass('button-primary')) {
      var postId = $(this).data('postId');
      $(this).removeData('postId');
      $.ajax({
        url: ajaxurl,
        type: 'POST',
        cache: false,
        data: {
          action: 'delete_post',
          security : gfwObject.gfwnonce,
          id: postId
        },
        success: function() {
          removed = 'table.gfw-table tr#post-' + postId;
          if ($(removed + ' a').hasClass('report-expanded')) {
            $(removed).next().hide();
          }
          $(removed).hide();
          $('table.gfw-table tr').removeClass('odd even');
          $('table.gfw-table tr:visible:odd').addClass('odd');
          $('table.gfw-table tr:visible:even').addClass('even');
        }
      });
    }
    $('#gfw-confirm-delete .gfw-modal-close').click();
  });
  
  $('.gfw-delete-icon').live('click', function(e) {
    e.preventDefault();
    $(this).overlay({
      mask: {
        color: "#fff",
        loadSpeed: 200,
        opacity: 0.6
      },
      close: '.gfw-modal-close',
      load: true,
      onBeforeLoad: function() {
        var postId = this.getTrigger().attr('id').substring(7);
        $('#gfw-confirm-delete a.button-primary').data('postId', postId);
      }
    });
  });

  $('.gfw-conditions select[name^="gfw_condition"]').live('change', function() {
    $(this).siblings('select:not(.' + $(this).val() + ')').hide();
    $(this).siblings('select.' + $(this).val()).show();
  })

  $('#gfw-add-condition a').bind('click', function() {
    $('.gfw-conditions:hidden:first').show().find('.gfw-condition').removeAttr('disabled').trigger('change');
    if ($('.gfw-conditions:visible').length == 4) {
      $(this).parents('tr').hide();
    }
  })
  
  $('.gfw-remove-condition').live('click', function() {
    $(this).parents('tr').hide().find('.gfw-condition').attr('disabled', 'disabled');
    $('#gfw-add-condition').show();
  })
  
  if (! $('#gfw-notifications').attr('checked')) {
    $('.gfw-conditions select:visible').attr('disabled', 'disabled');
  }

  $('input#gfw-notifications').bind('change', function() {
    if ($(this).is(':checked')) {
      $('.gfw-conditions select:visible').removeAttr('disabled');
      if ($('.gfw-conditions:visible').length < 4) {
        $('#gfw-add-condition').show();
      }
    } else {
      $('.gfw-conditions select:visible').attr('disabled', 'disabled');
      $('#gfw-add-condition').hide();
    }
    return false;
  })
  
  $('#gfw-test-front').bind('click', function() {
    $('#gfw_url').val($('#gfw-wpurl').val());
    $('#gfw-parameters').submit();
    return false;
  })
  
  $('.gfw-add-tooltip-right').tooltip({
    tipClass: 'gfw-tooltip',
    position: 'center right',
    offset: [0, 16],
    delay: 250,
    predelay: 250
  });
  
  $('.gfw-add-tooltip-left').tooltip({
    tipClass: 'gfw-tooltip',
    position: 'center left',
    offset: [0, -16],
    delay: 250,
    predelay: 250
  });
              


         
        
                
});